<template>
  <el-dialog
    title="工作单元选择"
    v-if="showFlag"
    :visible.sync="showFlag"
    :modal="false"
    width="80%"
  >
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-form-item label="工作单元编码" prop="workunitCode">
        <el-input
          v-model="queryParams.workunitCode"
          placeholder="请输入工单编码"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="工作单元名称" prop="workunitName">
        <el-input
          v-model="queryParams.workunitName"
          placeholder="请输入工作单元名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="工作站" prop="workstationName">
        <el-input
          v-model="queryParams.workstationName"
          placeholder="请输入工作站名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>
    <el-table
      v-loading="loading"
      :data="workunitList"
      @current-change="handleCurrent"
      @row-dblclick="handleRowDbClick"
      height="500px"
    >
      <el-table-column width="55" align="center">
        <template v-slot="scope">
          <el-radio
            v-model="selectedWorkunitId"
            :label="scope.row.workunitId"
            @change="handleRowChange(scope.row)"
            >{{ "" }}</el-radio
          >
        </template>
      </el-table-column>
      <el-table-column label="工作站名称" width="180" prop="workstationName" />
      <el-table-column
        label="工作单元编码"
        width="200"
        align="center"
        prop="workunitCode"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="工作单元名称" align="center" prop="workunitName" />
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <div slot="footer" class="dialog-footer">
      <el-button @click="showFlag = false">取 消</el-button>
      <el-button type="primary" @click="confirmSelect">确 定</el-button>
    </div>
  </el-dialog>
</template>
<script>
import { listWorkunit } from "@/api/mes/md/workunit";
export default {
  name: "WorkunitSelectSingle",
  components: {},
  dicts: [],
  props: {
    workstationName: {
      type: String,
      default: "",
    },
    workunitId: {
      type: Number | undefined,
      default: undefined,
    }, //外部传入的工单过滤信息
  },
  data() {
    return {
      showFlag: false,
      // 遮罩层
      loading: true,
      // 选中数组
      selectedWorkunitId: undefined,
      selectedRows: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 生产工单表格数据
      workunitList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        workunitCode: null,
        workunitName: null,
        workstationId: null,
        workstationName: this.workstationName,
        workunitId: null,
        enableFlag: "Y",
      },
    };
  },
  watch: {
    showFlag: {
      handler(newName) {
        this.selectedWorkunitId = null
        this.selectedRows = []
      },
      immediate: true
    }
  },
  created() {
    this.getList();
    this.queryParams.workstationName = this.workstationName;
  },
  methods: {
    /** 查询生产工单列表 */
    getList() {
      this.loading = true;
      listWorkunit(this.queryParams).then((response) => {
        this.workunitList = response.rows;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    handleCurrent(row) {
        console.log(row);
      if (row) {
        this.selectedRows = row;
      }
    },
    // 单选选中数据
    handleRowChange(row) {
      if (row) {
        this.selectedRows = row;
      }
    },
    //双击选中
    handleRowDbClick(row) {
      if (row) {
        this.selectedRows = row;
        this.$emit("onSelected", this.selectedRows);
        this.showFlag = false;
      }
    },
    //确定选中
    confirmSelect() {
      if (this.selectedWorkunitId == null || this.selectedWorkunitId == 0) {
        this.$notify({
          title: "提示",
          type: "warning",
          message: "请至少选择一条数据!",
        });
        return;
      }
      this.$emit("onSelected", this.selectedRows);
      this.showFlag = false;
    },
  },
};
</script>
